
type loc = Lexing.position * Lexing.position

type 'a located = { loc : loc; node : 'a }

type constr = constr_node located
and constr_node = 
  | Cident of string
  | Cprop
  | Ctype of int
  | Capp of constr * constr
  | Carrow of constr * constr
  | Cforall of binder list * constr
  | Cfun of binder list * constr
  | Cmatch of constr * (string * constr) option * constr * branch list
  | Cfix of string * binder list * constr * constr

and binder = string located list * constr

and branch = string located list * constr

type decl = 
  | Parameter of string * constr
  | Definition of string * constr * constr
  | Inductive of string * binder list * constr * (string located * constr) list

type file = decl located list
